{	ץåȥե˰¸ʤ¿ʥ롼	}

unit ExtUtils;

interface

uses
	Types, SysUtils, SysConst, Classes, QGraphics, QControls, QForms;

	function	SplitString(const	Delimiter,S:string;OutStrings:TStrings;Limit:Integer=0):	Integer;
	procedure	StrToken(Strings:TStrings;const	Text,Delimiters:string);
	procedure	EnableControl(AControl:TWinControl;Enabled:Boolean);
	function	CompareFileName(FileName1,FileName2:string):	Boolean;
	function	ExpandFileNameEx(FileName,BaseDir:string):	string;

	function	StringsToPathFmt(Strings:TStrings):	string;
	function	HexDump(pMem:Pointer;Size:Integer;Strings:TStrings):	Boolean;

	function	RectInRect(const	BaseRect,InnerRect:TRect):	Boolean;
	procedure	OffsetPt(var	pt:TPoint;Width,Height:Integer);	overload;
	procedure	OffsetPt(var	pt:TPoint;Offset:TPoint;Sub:Boolean=False);	overload;

type
	TCpuType=(cpuOriginalOEM,cpuOverdrive,cpuDual,cpuReserved);

	TCpuFeature=(
		cfFPU,				// 0	åư˥å
		cfVME,				// 1	8086 ⡼ɶ
		cfDE,					// 2	ǥХåĥ
		cfPSE,				// 3	ڡĥ
		cfTSC,				// 4	ࡦס
		cfMSR,				// 5	ǥͭ쥸
		cfPAE,				// 6	ʪɥ쥹ĥ
		cfMCE,				// 7	ޥ󡦥å㳰
		cfCX8,				// 8	CMPXCHG8B ̿
		cfAPIC,				// 9	åAPIC
		cfReserved10,	//10
		cfSEP,				//11	®ƥࡦ
		cfMTRR,				//12	ꡦϰϥ쥸
		cfPGE,				//13	PTE Х롦ե饰
		cfMCA,				//14	ޥ󡦥åƥ
		cfCMOV,				//15	դž̿
		cfPAT,				//16	ڡ°ơ֥
		cfPSE_36,			//17	36 ӥåȡڡĥ
		cfPN,					//18	ץåֹ
		cfReserved19,	//19
		cfReserved20,	//20
		cfReserved21,	//21
		cfReserved22,	//22
		cfMMX,				//23	MMX ƥΥ
		cfFXSR,				//24	ư̿/MMX ƥΥ̿/ȥ꡼ߥSIMD ĥ̿ι®¸/
		cfXMM,				//25	ȥ꡼ߥSIMD ĥ̿
		cfReserved26,	//26
		cfReserved27,	//27
		cfReserved28,	//28
		cfReserved29,	//29
		cfReserved30,	//30
		cfReserved31	//31
	);

	TCpuFeatures=set	of	TCpuFeature;

	TCpuId=record
		Vendor:	array[0..12]	of	Char;
		Version:	DWORD;
		Stepping:	BYTE;
		Model:	BYTE;
		Family:	BYTE;
		CpuType:	TCpuType;
		case	Integer	of
			0:	(Features:	TCpuFeatures);
			1:	(Info:	DWORD);
	end;

	function	CpuIdAvailable:	Boolean;
	function	GetCpuId(var	CpuId:TCpuId):	Boolean;

	function	GetCPUUsage:	Integer;
	function	IsCpuBusy(Retry:Integer=3):	Boolean;

const
	SShortMonthNames:	array[1..12]	of	string=(
		SShortMonthNameJan,
		SShortMonthNameFeb,
		SShortMonthNameMar,
		SShortMonthNameApr,
		SShortMonthNameMay,
		SShortMonthNameJun,
		SShortMonthNameJul,
		SShortMonthNameAug,
		SShortMonthNameSep,
		SShortMonthNameOct,
		SShortMonthNameNov,
		SShortMonthNameDec
	);
	SLongMonthNames:	array[1..12]	of	string=(
		SLongMonthNameJan,
		SLongMonthNameFeb,
		SLongMonthNameMar,
		SLongMonthNameApr,
		SLongMonthNameMay,
		SLongMonthNameJun,
		SLongMonthNameJul,
		SLongMonthNameAug,
		SLongMonthNameSep,
		SLongMonthNameOct,
		SLongMonthNameNov,
		SLongMonthNameDec
	);
	SShortDayNames:	array[1..7]	of	string=(
		SShortDayNameSun,
		SShortDayNameMon,
		SShortDayNameTue,
		SShortDayNameWed,
		SShortDayNameThu,
		SShortDayNameFri,
		SShortDayNameSat
	);

	SLongDayNames:	array[1..7]	of	string=(
		SLongDayNameSun,
		SLongDayNameMon,
		SLongDayNameTue,
		SLongDayNameWed,
		SLongDayNameThu,
		SLongDayNameFri,
		SLongDayNameSat
	);

type
	TGetCPUUsageProc=function:	Integer	of	object;

var
	GetCPUUsageProc:	TGetCPUUsageProc;

implementation

function	SplitString(const	Delimiter,S:string;OutStrings:TStrings;Limit:Integer=0):	Integer;
var
	Idx:	Integer;
	Pos:	Integer;
	Len:	Integer;
begin
	Result:=0;
	Len:=Length(Delimiter);
	Idx:=1;
	if	Length(S)=0	then	Exit;

	while	True	do
	begin
		if	(Limit>0)	and	(Result>=Limit-1)	then	Break;

		Pos:=AnsiPos(Delimiter,PChar(@S[Idx]))-1;
		if	Pos<0	then	Break;

		OutStrings.Add(Copy(S,Idx,Pos));
		Inc(Idx,Pos+Len);
		Inc(Result);
	end;
	OutStrings.Add(PChar(@S[Idx]));
	Inc(Result);
end;

procedure	StrToken(Strings:TStrings;const	Text,Delimiters:string);
var
	i,s,e:	Integer;
	InQuot:	Boolean;
begin
	InQuot:=False;
	s:=1;
	for	i:=1	to	Length(Text)	do
	begin
		if	IsDelimiter(Delimiters,Text,i)	then
		begin
			if	InQuot	then	e:=i+1
			else              e:=i;

			InQuot:=not	InQuot;
			Strings.Add(Copy(Text,s,e-s));
			s:=e;
		end;
	end;
	Strings.Add(Copy(Text,s,Length(Text)));
end;

{
procedure	StrToken(Strings:TStrings;const	Text,Delimiters:string);
var
	i,s,e:	Integer;
	State:	Integer;
begin
	s:=1;	State:=0;
	for	i:=1	to	Length(Text)	do
	begin
		if	IsDelimiter(Delimiters,Text,i)	then
			State:=(5-State)	mod	4
		else
			case	State	of
				1,3:
				begin
					e:=i;
					if	State=1	then	Dec(e);
					State:=(State+1)	mod	4;
					if	s<>e	then
					begin
						Strings.Add(Copy(Text,s,e-s));
						s:=e;
					end;
				end;
			end;
	end;
	Strings.Add(Copy(Text,s,Length(Text)));
end;

	ȥޥȥǥǹͤ롣
	q0:Delimiter Off()
	q1:Delimiter Off+Delimiter
	q2:Delimiter On
	q3:Delimiter On+Delimiter

	ɽ
		Delimiter	ʳ
	q0		q1			q0
	q1		q0      q2
	q2    q3      q2
	q3    q2      q0
}

procedure	EnableControl(AControl:TWinControl;Enabled:Boolean);
var
	i:	Integer;
begin
//	AControl.Enabled:=Enabled;
	for	i:=0	to	AControl.ControlCount-1	do
		AControl.Controls[i].Enabled:=Enabled;
end;

function	CompareFileName(FileName1,FileName2:string):	Boolean;
begin
	Result:=CompareText(
						ExcludeTrailingPathDelimiter(FileName1),
						ExcludeTrailingPathDelimiter(FileName2)
					)=0;
end;

function	ExpandFileNameEx(FileName,BaseDir:string):	string;
var
	pwd:	string;
begin
	pwd:=GetCurrentDir;
	ChDir(BaseDir);
	Result:=ExpandFileName(FileName);
	ChDir(pwd);
end;

function	StringsToPathFmt(Strings:TStrings):	string;
begin
	Result:=StringReplace(Strings.CommaText,',',';',[rfReplaceAll]);
end;

function	HexDump(pMem:Pointer;Size:Integer;Strings:TStrings):	Boolean;

	function	DumpSubProc(p:PChar;len:Integer):	string;
	var
		i:	Integer;
		Buffer:	array[0..15]	of	Char;
		Line:	ShortString;
	begin
		FillChar(Buffer,SizeOf(Buffer),#0);
		Move(p^,Buffer,len);

		Line:='';
		for	i:=0	to	len-1	do
		begin
			if	Buffer[i]	in	[#0..#31,#127,#255]	then	Buffer[i]:='.';
			Line:=Line+Format('%.2x ',[Byte(p[i])]);
		end;

		for	i:=len	to	15	do
		begin
			Line:=Line+'   ';
			Buffer[i]:=' ';
		end;

		Result:=Line+Buffer;
	end;

var
	ExtraSize:	Integer;
	i:	Integer;
begin
	Result:=True;

	ExtraSize:=Size	mod	16;
	for	i:=0	to	((Size-ExtraSize)	div	16)-1	do
	begin
		Strings.Add(DumpSubProc(pMem,16));
		pMem:=@PChar(pMem)[16];
	end;
	if	ExtraSize>0	then
		Strings.Add(DumpSubProc(pMem,ExtraSize));
end;

function	RectInRect(const	BaseRect,InnerRect:TRect):	Boolean;
begin
//	Result:=PtInRect(BaseRect,InnerRect.TopLeft)	and
//					PtInRect(BaseRect,InnerRect.BottomRight);
	Result:=(BaseRect.Left<=InnerRect.Left)	and
					(BaseRect.Top<=InnerRect.Top)	and
					(BaseRect.Right>=InnerRect.Right)	and
					(BaseRect.Bottom>=InnerRect.Bottom);
end;

procedure	OffsetPt(var	pt:TPoint;Width,Height:Integer);
begin
	Inc(pt.x,Width);
	Inc(pt.y,Height);
end;

procedure	OffsetPt(var	pt:TPoint;Offset:TPoint;Sub:Boolean=False);
begin
	if	Sub	then
		OffsetPt(pt,-Offset.x,-Offset.y)
	else
		OffsetPt(pt,Offset.x,Offset.y)
end;

function	CpuIdAvailable:	Boolean;
asm
	//EFLAGSecx˼,edx¸
	pushfd
	pop	ecx
	mov	edx,ecx

	//IDե饰򥻥å
	xor	ecx,$200000
	push	ecx
	popfd

	//ѹȿǤƤ롩
	pushfd
	pop	ecx
	xor	eax,eax
	xor	ecx,edx
	setnz	al

	//EFLAG򸵤᤹
	push	edx
	popfd
end;

procedure	GetCpuVendor(Buffer:PChar);
asm
	push	ebx
	push	eax	//

	//eax=0:٥ʸμ
	xor	eax,eax
	db	$0f,$a2	//CPUID

	pop	eax
	mov	[eax+0],ebx
	mov	[eax+4],edx
	mov	[eax+8],ecx
	mov	BYTE[eax+12],0

	pop	ebx
end;

procedure	GetCpuInfo(var	Version,Info:DWORD);
asm
	push	ebx

	push	edx	//
	push	eax	//

	//eax=1:Сֹ,ǽμ
	mov	eax,1
	db	$0f,$a2	//CPUID

	pop	ecx
	mov	[ecx],eax
	pop	ecx
	mov	[ecx],edx

	pop	ebx
end;

{$J+}
function	GetCpuId(var	CpuId:TCpuId):	Boolean;
const
	State:	Integer=0;
	StoredData:	TCpuId=();
begin
	if	State=0	then
	begin
		State:=-1;

		if	CpuIdAvailable	then
		begin
			with	StoredData	do
			begin
				GetCpuVendor(Vendor);
				GetCpuInfo(Version,Info);

				Stepping:=Version	and	$0f;
				Model:=(Version	shr	4)	and	$0f;
				Family:=(Version	shr	8)	and	$0f;
				CpuType:=TCpuType((Version	shr	12)	and	$0f);
			end;

			State:=1;
		end;
	end;

	Result:=State>0;
	if	Result	then	CpuId:=StoredData;
end;

function	GetCPUUsage:	Integer;
begin
	if	Assigned(@GetCPUUsageProc)	then
		Result:=GetCpuUsageProc
	else
		Result:=-1;
end;

function	IsCpuBusy(Retry:Integer=3):	Boolean;
begin
	Result:=False;

	while	True	do
	begin
		if	GetCPUUsage<100	then	Exit;
		Dec(Retry);
		if	Retry<=0	then	Break;
		Sleep(1000);
	end;

	Result:=True;
end;

end.

