unit MainFrm;

interface

uses
	SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QImgList, QExtCtrls, QMenus, Math, Qt, Xlib,
  MainDoc, LinuxExt, ExtStrm, WidgetShape;

type
	TMoveEvent=procedure(Sender:TObject;X,Y:Integer)	of	object;

	TForm1 = class(TForm)
		Timer1: TTimer;
		ImageList1: TImageList;
		PopupMenu1: TPopupMenu;
		Exit1: TMenuItem;
		Setup1: TMenuItem;
		Minimize1: TMenuItem;
		Help1: TMenuItem;
		About1: TMenuItem;
		GoTo1: TMenuItem;
		OpenDesktop: TMenuItem;
		N1: TMenuItem;
		C1: TMenuItem;
		N2: TMenuItem;
		N3: TMenuItem;
		T1: TMenuItem;
		N4: TMenuItem;
		N5: TMenuItem;
		N6: TMenuItem;
		N7: TMenuItem;
		N8: TMenuItem;
		F1: TMenuItem;
    N9: TMenuItem;
		Desktop1: TMenuItem;
		N11: TMenuItem;
    N12: TMenuItem;
    S1: TMenuItem;
    P1: TMenuItem;
		N01: TMenuItem;
    N10: TMenuItem;
    C2: TMenuItem;
    LargeSysImages: TImageList;
    SmallSysImages: TImageList;
    Timer2: TTimer;
    OpenDialog1: TOpenDialog;
    Open1: TMenuItem;
		procedure FormCreate(Sender: TObject);
		procedure FormDestroy(Sender: TObject);
		procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
		procedure FormPaint(Sender: TObject);
		procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
			Shift: TShiftState; X, Y: Integer);
		procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
			Y: Integer);
		procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
		procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
		procedure Setup1Click(Sender: TObject);
		procedure Minimize1Click(Sender: TObject);
		procedure Help1Click(Sender: TObject);
		procedure About1Click(Sender: TObject);
		procedure MoveClick(Sender: TObject);
		procedure F1Click(Sender: TObject);
		procedure T1Click(Sender: TObject);
		procedure P1Click(Sender: TObject);
		procedure C2Click(Sender: TObject);
		procedure N01Click(Sender: TObject);
		procedure N12Click(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
	private
		{ Private  }
		FDocument:	TDocForm1;
    FFormShape:	TWidgetShape;
		FFormBitmap:	TBitmap;
		FViewStyle:	TViewStyle;
		FChangeTimer:	TStopWatch;
		FIgnoreWindowChange:	Boolean;
//		FOnMove:	TMoveEvent;
		FCanRun:	Boolean;
//		FSelfActivateMessage:	UINT;
		FShareMem:	TShareableMemoryStream;
		FLocked:  Boolean;
		FHasPicture:	Boolean;
		FOptMinimize:	Boolean;
		FOptReadOnly:	Boolean;
//		FFileChangeNotifyThread:	TFileChangeNotifyThread;
		FDragOver:	Boolean;
    FDragOffset:	TPoint;
		procedure	AssignShape;
		procedure	AddMenuItem(Caption:string;Enabled:Boolean);
	protected
//		procedure	CreateParams(var	Params:TCreateParams);	override;
//		procedure	CreateWnd;	override;
//		procedure	WMMove(var	Msg:TWMMove);	message	WM_MOVE;
//		procedure	WMEraseBkgrgnd(var	Msg:TWMEraseBkgnd);	message	WM_ERASEBKGND;
//		procedure	WMDropFiles(var	Msg:TWMDropFiles);	message	WM_DROPFILES;
//		procedure	WMInitialShow(Var	Msg:TMessage);	message	WM_INITIALSHOW;
  	procedure	InitialShow;
//		procedure	WMSettingChange(var	Msg:TWMSettingChange);	message	WM_SETTINGCHANGE;
//		procedure	WMTimeChange(var	Msg:TWMTimeChange);	message	WM_TIMECHANGE;
//		procedure	WMQueryEndSession(var	Msg:TWMQueryEndSession);	message	WM_QUERYENDSESSION;
//		function	GetPalette:	HPALETTE;	override;
		procedure	SetViewStyle(Style:TViewStyle);
//		procedure	SetFormShape;
		procedure	Initialize;
		procedure	SetupDlgActivate;
		procedure	AboutBoxActivate;
//		procedure	MenuItemClick(Sender:TObject);
		function	IsOption(OptStr:string):	Boolean;
//		procedure	StartDesktopMonitoring;
//		procedure	EndDesktopMonitoring;
//		procedure	DesktopChangeNotify(Sender:TObject);
//		procedure	DesktopChangeTerminate(Sender:TObject);
//		procedure	DesktopIconChange;
		procedure	AddDelayMenu(MenuItem:TMenuItem);
		procedure FolderMenuClick(Sender: TObject);
		procedure FolderSubMenuClick(Sender: TObject);
		procedure	SelfActivate;
//		procedure ApplicationEvents1Message(var Msg: tagMSG;
//			var Handled: Boolean);
		procedure ApplicationEvents1ShowHint(var HintStr: WideString;
			var CanShow: Boolean; var HintInfo: THintInfo);
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
		procedure	ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
	public
		{ Public  }
		procedure ChangeMascotClick(Sender: TObject);
		procedure	InvalidateMenuItem;
		procedure	UpdatePosition;
		procedure	UpdateTopMost;
		procedure	UpdateView;
		procedure	MascotChanged;
		procedure	SetPosition(Sender:TObject;x,y:Integer);	overload;
		procedure	SetPosition(Sender:TObject;Point:TPoint);	overload;
		procedure	CreateFolderMenu;
		function	GetMascotSubMenu:	TMenuItem;
		property	MascotSubMenu:	TMenuItem	read	GetMascotSubMenu;
		property	Document:	TDocForm1	read	FDocument;
		property	FormBitmap:	TBitmap	read	FFormBitmap;
    property	FormShape:	TWidgetShape	read	FFormShape	{write	SetFormShape};
		property	ChangeTimer:	TStopWatch	read	FChangeTimer;
		property	ViewStyle:	TViewStyle	read	FViewStyle	write	SetViewStyle;
		property	CanRun:	Boolean	read	FCanRun;
		property  Locked: Boolean read  FLocked write FLocked;
		property	HasPicture:	Boolean	read	FHasPicture	write	FHasPicture;
	published
		procedure	Form1WindowChanged(Sender:TObject);
		procedure	Form1ViewStyleChange(Sender:TObject;Style:TViewStyle);
//		property	OnMove:	TMoveEvent	read	FOnMove	write	FOnMove;
	end;

var
	Form1: TForm1;

implementation

uses
	{SetupFrm, }AboutFrm, ExtUtils, {SNTPThrd, }Mascot;

{$R *.xfm}

//------------------------------------------------------------

{	MenuItem	}

function	TForm1.GetMascotSubMenu:	TMenuItem;
begin
	Result:=PopupMenu1.Items[0];
end;

procedure	TForm1.AddMenuItem(Caption:string;Enabled:Boolean);
var
	AMenuItem:	TMenuItem;
	Idx:	Integer;
begin
	Idx:=MascotSubMenu.Count-2;
	AMenuItem:=TMenuItem.Create(Self);
	AMenuItem.Caption:=Caption+'(&'+Chr(ord('1')+Idx)+')';
	AMenuItem.Enabled:=Enabled;
	AMenuItem.RadioItem:=True;
	AMenuItem.GroupIndex:=1;
	AMenuItem.Tag:=Idx;
	if	Enabled	then
		AMenuItem.OnClick:=ChangeMascotClick;

	MascotSubMenu.Add(AMenuItem);
end;

procedure	TForm1.InvalidateMenuItem;
var
	i:	Integer;
begin
//	MascotSubMenu.Clear;

	with	MascotSubMenu	do
	begin
		for	i:=Count-1	downto	2	do
			Items[i].Free;
	end;

	with	Document	do
	begin
		T1.Checked:=TopMost;
		F1.Checked:=WindowFollowing;
		C2.Checked:=UseCaptionFmt;

		if	MascotList.Count=0	then
			AddMenuItem('(ʤ)',False)
		else	begin
			for	i:=0	to	MascotList.Count-1	do
				AddMenuItem(MascotList[i].Name,True);
			if	CurrentMascot>=0	then
				MascotSubMenu[CurrentMascot].Checked:=True;
			SplitMenu(MascotSubMenu);
		end;
	end;
end;

{
procedure	TForm1.MenuItemClick(Sender:TObject);
begin
	PerformDefaultAction(PItemIDList((Sender	as	TMenuItem).Tag));
end;

procedure	TForm1.DesktopChangeNotify(Sender:TObject);
begin
	DesktopIconChange;
end;

procedure	TForm1.DesktopChangeTerminate(Sender:TObject);
begin
	if	Sender=FFileChangeNotifyThread	then
		FFileChangeNotifyThread:=nil
	else
		ShowMessage('OnTerminateʰ');
end;

procedure	TForm1.StartDesktopMonitoring;
begin
	if	Assigned(FFileChangeNotifyThread)	then	Exit;

	FFileChangeNotifyThread:=TFileChangeNotifyThread.Create;
	with	FFileChangeNotifyThread	do
	begin
		OnChange:=DesktopChangeNotify;
		OnTerminate:=DesktopChangeTerminate;
		FilePath:=GetSpecialFolderPath(CSIDL_DESKTOPDIRECTORY);
		Resume;
	end;
end;

procedure	TForm1.EndDesktopMonitoring;
begin
	if	Assigned(FFileChangeNotifyThread)	then
		FFileChangeNotifyThread.Terminate;
end;
}

(*
procedure	TForm1.DesktopIconChange;
var
//	i:	Integer;
//	MenuItem:	TMenuItem;
	Item0:	TMenuItem;
	Item1:	TMenuItem;
begin
//	Form2.BuildListItem;

	with	Desktop1	do
	begin
		Item0:=Items[0];
		Item1:=Items[1];
		Delete(0);
		Delete(0);
		Clear;
		Add(Item0);
		Add(Item1);
	end;

{
	for	i:=0	to	Form2.ListView1.Items.Count-1	do
		with	Form2.ListView1.Items[i]	do
		begin
			MenuItem:=TMenuItem.Create(Self);
			MenuItem.Caption:=Caption;
			MenuItem.ImageIndex:=ImageIndex;
			MenuItem.Tag:=Integer(Data);
			MenuItem.OnClick:=MenuItemClick;
			Desktop1.Add(MenuItem);
		end;
}

	SplitMenu(Desktop1);
end;
*)

//------------------------------------------------------------

procedure	TForm1.SetViewStyle(Style:TViewStyle);
begin
	if	ViewStyle<>Style	then
	begin
		case	Style	of
		vsNormal:
			begin
				FViewStyle:=vsNormal;
				UpdatePosition;
				Visible:=True;
				Minimize1.Caption:='Ǿ(&M)';
				MascotSubMenu.Enabled:=True;
				Goto1.Enabled:=True;
//				SetForegroundWindow(Document.WindowParams.Handle);
			end;

		vsHidden:
			begin
//				BringWindowToTop();
//				FIgnoreWindowChange:=(Document.WindowParams.Handle=Handle);
				FViewStyle:=vsHidden;
				Visible:=False;
//				if	GetForegroundWindow=Handle	then
//					Document.MarkedWindow:=GetWindow(Handle,GW_HWNDNEXT);
//				Document.MarkedWindow:=GetForegroundWindow;
			end;

		vsMinimized:
			begin
				FViewStyle:=vsMinimized;
				Visible:=False;
				Minimize1.Caption:='᤹(&R)';
				MascotSubMenu.Enabled:=False;
				Goto1.Enabled:=False;
			end;

		end;
	end;
end;

//------------------------------------------------------------

{	Main	}

function	TForm1.IsOption(OptStr:string):	Boolean;
begin
	Result:=(OptStr[1]	in	['-','/']);

	if	Result	then
	begin
		OptStr:=UpperCase(PChar(@OptStr[2]));

		if	Pos('READONLY',OptStr)=1	then
			FOptReadOnly:=True
		else
		if	Pos('MIN',OptStr)=1	then
			FOptMinimize:=True;
	end;
end;

procedure	TForm1.AddDelayMenu(MenuItem:TMenuItem);
begin
	MenuItem.OnClick:=FolderSubMenuClick;
	MenuItem.Add(TMenuItem.Create(Self));
	with	MenuItem[0]	do
	begin
		Caption:='()';
		Tag:=MenuItem.Tag;
		OnClick:=FolderMenuClick;
	end;
end;

procedure TForm1.FolderMenuClick(Sender: TObject);
//var
//	sei:	TShellExecuteInfo;
//	pidl:	PItemIDList;
begin
	Assert(Sender	is	TMenuItem);

{
	pidl:=PItemIDList((Sender	as	TMenuItem).Tag);

	ZeroMemory(@sei,SizeOf(sei));
	sei.cbSize:=SizeOf(sei);
	sei.Wnd:=Application.Handle;
	sei.nShow:=SW_SHOWNORMAL;
	sei.lpIDList:=pidl;

	if	pidl.mkid.cb=0	then
		sei.fMask:=SEE_MASK_IDLIST
	else
		sei.fMask:=SEE_MASK_INVOKEIDLIST;

	Win32Check(ShellExecuteEx(@sei));
}
end;

procedure TForm1.FolderSubMenuClick(Sender: TObject);
var
	MenuItem:	TMenuItem;
//	Enum:	IEnumIDList;
//	Item:	TMenuItem;
//	pidlParent:	PItemIDList;
//	pidl:	PItemIDList;
//	rgelt:	PItemIDList;
//	Fetched:	Cardinal;
//	sfi:	TSHFileInfo;
begin
	Assert(Sender	is	TMenuItem);

	MenuItem:=Sender	as	TMenuItem;
	with	MenuItem	do
	begin
{
		pidlParent:=PItemIDList(Tag);
		Tag:=0;

		Enum:=GetEnumIDList(pidlParent,SHCONTF_FOLDERS	or	SHCONTF_NONFOLDERS);
		while	Enum.Next(1,rgelt,Fetched)=NOERROR	do
		begin
			pidl:=ConcatItemIDList(pidlParent,rgelt);
			Mallocator.Free(rgelt);

			SHGetFileInfo(PChar(pidl),0,sfi,SizeOf(sfi),SHGFI_PIDL	or	SHGFI_DISPLAYNAME	or	SHGFI_SMALLICON	or	SHGFI_SYSICONINDEX);
			Item:=TMenuItem.Create(Self);
			Item.Caption:=sfi.szDisplayName;
			Item.ImageIndex:=sfi.iIcon;
			Item.Tag:=Integer(pidl);
			if	(MenuItem.Parent=Folder1)	and	(not	Document.FolderMenuList[MenuItem.MenuIndex].SubMenuRecursive)	then
				Item.OnClick:=FolderMenuClick
			else
				AddDelayMenu(Item);

			Add(Item);
		end;
		if	Count>1	then	Insert(1,NewLine);

		OnClick:=nil;
}
	end;
	SplitMenu(MenuItem);
end;

procedure	TForm1.CreateFolderMenu;
//var
//	i:	Integer;
//	MenuItem:	TMenuItem;
//	Item:	TFolderMenuItem;
begin
{
	Folder1.Clear;
	with	Document	do
	begin
		case	IconState	of
			isNone:		Folder1.SubMenuImages:=nil;
			isLarge:	Folder1.SubMenuImages:=Form1.LargeSysImages;
			isSmall:	Folder1.SubMenuImages:=Form1.SmallSysImages;
		end;

		for	i:=0	to	FolderMenuList.Count-1	do
		begin
			Item:=FolderMenuList[i];
			if	Item.Enabled	then
			begin
				MenuItem:=TMenuItem.Create(Self);
				MenuItem.Caption:=Item.DisplayName;
				MenuItem.ImageIndex:=Item.ImageIndex;
//				MenuItem.Tag:=Integer(Item.ItemIDList);

				if	Item.SubMenu	or	Item.SubMenuRecursive	then
					AddDelayMenu(MenuItem)
				else
					MenuItem.OnClick:=FolderMenuClick;


				Folder1.Add(MenuItem);
			end;
		end;
	end;
	SplitMenu(Folder1);
}
end;

procedure	TForm1.Initialize;
const
	ServerFileName='Server.txt';
begin
	with	Document	do
	begin
		if	InitialChange	then
			RandomChange(False);
	end;

{
	if	FileExists(ServerFileName)	then
	try
		NTPServerList.LoadFromFile(ServerFileName);
	except
		on	EFOpenError	do;
	end;
}

	UpdateView;

	ChangeTimer.Start;

{
	if	SystemParametersInfo(SPI_GETSCREENSAVEACTIVE,0,@bParam,0)	then
		P1.Checked:=not	bParam
	else
		P1.Enabled:=False;
}

//	FlashTimer.EnableFreq:=True;
end;

procedure	TForm1.SetPosition(Sender:TObject;x,y:Integer);
//var
//	hwndInsertAfter:	HWND;
begin
	if	(Left<>x)	or	(Top<>y)	then
		with	Document	do
		begin
(*
			if	ZOrderControl	then
			begin
{
				if	Handle=WindowParams.Handle	then
					hwndInsertAfter:=HWND_TOP
				else
					hwndInsertAfter:=WindowParams.Handle;
				SetWindowPos(Handle,hwndInsertAfter,x,y,0,0,SWP_NOACTIVATE	or	SWP_NOSIZE);
}

				if		FormStyle=fsStayOnTop	then
				begin
{
					SetWindowPos(Handle,HWND_TOPMOST,0,0,0,0,SWP_NOACTIVATE	or	SWP_NOSIZE	or	SWP_NOMOVE);
	//				SetWindowPos(Document.WindowParams.Handle,Handle,0,0,0,0,SWP_NOACTIVATE	or	SWP_NOSIZE	or	SWP_NOMOVE);
}
				end;
			end
//			else
*)
				SetBounds(x,y,Width,Height);
		end;
end;

procedure	TForm1.SetPosition(Sender:TObject;Point:TPoint);
begin
	SetPosition(Self,Point.x,Point.y);
end;

procedure	TForm1.Form1WindowChanged(Sender:TObject);
begin
	if	ViewStyle=vsHidden	then
	begin
		if	FIgnoreWindowChange	then
			FIgnoreWindowChange:=False
		else	begin
			ViewStyle:=vsNormal;
//			SetForegroundWindow(Document.WindowParams.Handle);
		end;
	end;
end;

procedure	TForm1.Form1ViewStyleChange(Sender:TObject;Style:TViewStyle);
begin
	ViewStyle:=Style;
end;

procedure	TForm1.AssignShape;
begin
	if	HasPicture	then
	begin
		FormShape.Bitmap.Assign(Document.MascotList.Mask);
		SetBounds(Left,Top,FormBitmap.Width,FormBitmap.Height);
	end	else	begin
		SetBounds(Left,Top,300,200);
		with	FormShape.Bitmap.Canvas	do
    begin
    	Brush.Color:=clMask;
			FillRect(ClientRect);
    	Brush.Color:=clDontMask;
	    RoundRect(0,0,Width,Height,50,50);
    end;
	end;
	FFormShape.Shape;

	UpdatePosition;
end;

procedure	TForm1.UpdateTopMost;
begin
	if	Document.TopMost	then
		FormStyle:=fsStayOnTop
	else
		FormStyle:=fsNormal;
end;

procedure	TForm1.MascotChanged;
begin
	with	Document	do
	try
		MascotList.LoadPicture;
	except
		on	EInvalidGraphic	do
			ShowMessageFmt('%sͭʲեǤϤޤ',[MascotList[CurrentMascot].Picture]);
		on	EFOpenError	do
			ShowMessageFmt('ե뤬ޤ: %s',[MascotList[CurrentMascot].Picture]);
	end;

	HasPicture:=Assigned(Document.MascotList.Picture);

	if	HasPicture	then
	begin
		with	Document.MascotList	do
		begin
			FormBitmap.Assign(Picture.Graphic);
			if	ItemIndex>=0	then
			begin
				MascotSubMenu[ItemIndex+2].Checked:=True;
				with	CurrentMascot	do
				begin
					Hint:=Name;
					UpdatePosition;
				end;
			end;
		end;
	end;
	AssignShape;
	Invalidate;

	ChangeTimer.Reset;
end;

procedure	TForm1.UpdateView;
begin
	with  Document  do
		Timer1.Enabled:=WindowFollowing or
										DefButtonEnable or
										(CaptionFmt<>'')	{or
										(Field.BlinkerParams.Kind<>akNone)	or
										(Field.ShakerParams.Kind<>akNone)	or
										(Field.PlayerParams.Kind<>akNone)};

	Timer1.Interval:=Document.TimerInterval;
	UpdateTopMost;
	InvalidateMenuItem;
	MascotChanged;
//	Document.UpdateACFont;

	ShowHint:=Document.ShowHint;
	Application.HintColor:=Document.HintColor;
end;

procedure	TForm1.UpdatePosition;
var
	pt:	TPoint;
begin
	if	Document.WindowFollowing	and
			(ViewStyle=vsNormal)	then
	begin
		pt:=Point(Left,Top);
		Document.UpdatePosition(pt,FormShape.Rect);
		SetPosition(Self,pt);
	end;
end;

procedure	TForm1.SetupDlgActivate;
begin
//	if	Assigned(SetupDlg)	then	Exit;

//	SetupDlg:=TSetupDlg.Create(Self);
//	SetupDlg.Show;
end;

procedure	TForm1.AboutBoxActivate;
begin
	if	Assigned(AboutBox)	then	Exit;

	AboutBox:=TAboutBox.Create(Self);
	AboutBox.Show;
end;

procedure	TForm1.InitialShow;
begin
	Initialize;

	if	FOptMinimize	then
		ViewStyle:=vsMinimized
	else
		ViewStyle:=vsNormal;

	if	(not	HasPicture)	and
			(ViewStyle=vsNormal)	then
		SetupDlgActivate;
end;

procedure	TForm1.SelfActivate;
begin
  if	ViewStyle=vsMinimized	then
    ViewStyle:=vsNormal
  else
    SetupDlgActivate;
end;

//------------------------------------------------------------

{	Messages	}

(*
procedure	TForm1.WMInitialShow(Var	Msg:TMessage);
begin
	InitialShow;
end;

procedure	TForm1.WMTimeChange(var	Msg:TWMTimeChange);
begin
	inherited;

	Document.SetTimeDifference(0);
end;

procedure	TForm1.WMDropFiles(var	Msg:TWMDropFiles);
begin
	inherited;

	//ؤΥɥåפˤؤ
	SetupDlgActivate;
//	SetupDlg.WMDropFiles(Msg);
end;

procedure	TForm1.WMSettingChange(var	Msg:TWMSettingChange);
begin
	inherited;

	if	Msg.Flag=SPI_SETNONCLIENTMETRICS	then
	begin
//		ShowMessageFmt('WMSettingChange(%.8x,%s)',[Msg.Flag,string(Msg.Section)]);
		if	Document.UseDesktop	then
		begin
			DesktopIconChange;
			CreateFolderMenu;
//			InitSysImageList(LargeSysImages,SmallSysImages);
		end;
	end;
{
	Document.StoreACFont;
	UpdateView;
}
end;

procedure	TForm1.WMQueryEndSession(var	Msg:TWMQueryEndSession);
begin
	inherited;

//	ShowMessage('QueryEndSession');
end;

function	TForm1.GetPalette:	HPALETTE;
begin
	Result:=FormBitmap.Palette;
end;
*)

//------------------------------------------------------------

{	ApplicationEvents	}

(*
procedure TForm1.ApplicationEvents1Message(var Msg: tagMSG;
	var Handled: Boolean);
begin
	if	Msg.message=FSelfActivateMessage	then
	begin
  	SelfActivate;
		Handled:=True;
	end
{
	else
	if	Msg.message=WM_ENDSESSION	then
		ShowMessage('WM_ENDSESSION');
}
end;
*)

procedure TForm1.ApplicationEvents1ShowHint(var HintStr: WideString;
	var CanShow: Boolean; var HintInfo: THintInfo);
begin
	with  HintInfo  do
	begin
		if  HintControl=Form1	then
			//Hintɽäʤ
			ReshowTimeout:=HideTimeout;
	end;
end;

procedure TForm1.ApplicationEvents1Exception(Sender: TObject;
	E: Exception);
begin
	ShowMessage('㳰ȯޤ: '+E.Message);
end;

procedure	TForm1.ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
begin
	InitialShow;
  Application.OnIdle:=nil;
end;

//------------------------------------------------------------

{	FormEvents	}

(*
procedure	TForm1.CreateWnd;
begin
	inherited;

	if	Assigned(Document)	then	AssignShape;
end;

procedure	TForm1.CreateParams(var	Params:TCreateParams);
begin
	inherited;

	//Drag&Drop
	Params.ExStyle:=Params.ExStyle	or	WS_EX_ACCEPTFILES;

//	if	FormStyle=fsStayOnTop	then
		//ALT+TABɽ
		Params.ExStyle:=Params.ExStyle	or	WS_EX_TOOLWINDOW
//	else
//		Params.ExStyle:=Params.ExStyle	and	(not	WS_EX_TOOLWINDOW);
end;
*)

function	GetIniFilePath(FileName:string):	string;
var
	Path1,Path2:	string;
begin
	Path1:=IncludeTrailingPathDelimiter(GetCurrentDir)+FileName;
	Path2:=ExtractFilePath(Application.ExeName)+FileName;
	//INIե뤬ȥǥ쥯ȥˤʤƵưǥ쥯ȥˤ
	//ͥ褹롣ǤʤХȥǥ쥯ȥINIե򳫤
	if	(not	FileExists(Path1))	and	FileExists(Path2)	then
		Result:=Path2
	else
		Result:=Path1;
end;

procedure TForm1.FormCreate(Sender: TObject);
resourcestring
	IniFileName='ActMas.ini';
var
	hwndPrev:	TWindow;
	i:	Integer;
begin
	FDocument:=TDocForm1.Create(Self);
	FChangeTimer:=TStopWatch.Create;
	FShareMem:=CreateShareableMemoryStream;
	FFormBitmap:=TBitmap.Create;
  FFormShape:=TWidgetShape.Create(Self);

//	InitSysImageList(LargeSysImages,SmallSysImages);

//	FSelfActivateMessage:=RegisterWindowMessage('ActiveMascot::SelfActivateMessage');

	Locked:=False;

	ViewStyle:=vsNormal;
	Application.ShowMainForm:=False;

	with	Document	do
	begin
		for	i:=1	to	ParamCount	do
		begin
			if	IsOption(ParamStr(i))	then	Continue;
//			if	IniFile=''	then
//				IniFile:=ExpandFileName(GetLongPathName(ParamStr(i)));
		end;

		ReadOnly:=FOptReadOnly;

{
		if	FOptMinimize	then
		begin
			Application.ShowMainForm:=False;
			ViewStyle:=vsMinimize;
		end;
}

		OnPositionChanged:=SetPosition;
		OnWindowChanged:=Form1WindowChanged;
		OnViewStyleChange:=Form1ViewStyleChange;

		QWidget_setAcceptDrops(Handle,True);

		if	IniFile=''	then
			IniFile:=GetIniFilePath(IniFileName);

		try
			LoadIniFile;
		except
			on	E:	Exception	do
				ShowMessage('INIեɤ߹ߤǥ顼: '+E.Message);
		end;

		FCanRun:=True;
		if	(not	AllowDuplication)	and
    		(not	(FShareMem	is	TNullStream))	then
		begin
			//ŵưå
			with	FShareMem	do
			begin
				Name:='ActiveMascot';
				Size:=SizeOf(QWidgetH);
				Exclusive:=True;
				Allocate;

				if	Primary	then
				begin
					Putdw(QWidget_winId(Application.AppWidget));
				end	else	begin
					hwndPrev:=TWindow(Getdw);

					SetActiveWindow(hwndPrev);
					FCanRun:=False;
//					PostMessage(hwndPrev,FSelfActivateMessage,0,0);
					Exit;
				end;
			end;
		end;
	end;

	Application.OnIdle:=ApplicationEvents1Idle;
	Application.OnException:=ApplicationEvents1Exception;
  Application.OnShowHint:=ApplicationEvents1ShowHint;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
const
	EFCreatePrompt='INIե뤬Ǥޤ: %s';
	ExceptionPrompt='INIեؤν񤭤ߤǥ顼: %s';
var
	ret:	Word;
	Retry:	Boolean;
begin
	repeat
		Retry:=False;
		try
			Document.SaveIniFile;
		except
			on	EFCreateError	do
			begin
				ret:=MessageDlg(Format(EFCreatePrompt,[Document.IniFile]),mtError,mbAbortRetryIgnore,0);
				case	ret	of
//					mrAbort:	CanClose:=False;
					mrRetry:	Retry:=True;
					mrIgnore:	CanClose:=True;
					else			CanClose:=False;
				end;
			end;

			on	e:	Exception	do
			begin
				ret:=MessageDlg(Format(ExceptionPrompt,[e.Message]),mtError,mbAbortRetryIgnore,0);
				case	ret	of
//					mrAbort:	CanClose:=False;
					mrRetry:	Retry:=True;
					mrIgnore:	CanClose:=True;
					else			CanClose:=False;
				end;
			end;
		end;
	until	not	Retry;

	if	CanClose	then
	begin
		//ʹߤ˵륿ޡ٥Ȥ̵̤ʤΤǻߤ
		Timer1.Enabled:=False;
		Timer2.Enabled:=False;
	end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
{
	procedure	FreePIDLs(Item:TMenuItem);
	var
		pidl:	PItemIDList;
		i:	Integer;
	begin
		pidl:=PItemIDList(Item.Tag);
		Mallocator.Free(pidl);
		for	i:=0	to	Item.Count-1	do
			FreePIDLs(Item[i])
	end;
}
begin
//	FreePIDLs(Folder1);
	FShareMem.DeAllocate;

	Document.Free;
	ChangeTimer.Free;
	FShareMem.Free;
	FFormShape.Free;
	FFormBitmap.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
//	Canvas.Draw(0,0,FormShape.Bitmap);
//  Canvas.Brush.Color:=clDontMask;
//  Canvas.Brush.Style:=bsSolid;
//  Canvas.RoundRect(0,0,Width,Height,50,50);

	if	HasPicture	then
		Canvas.Draw(0,0,FormBitmap);
end;

{
procedure	TForm1.WMMove(var	Msg:TWMMove);
begin
	inherited;

	if	Assigned(FOnMove)	then
		FOnMove(Self,Msg.XPos,Msg.YPos);
end;
}

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
	Y: Integer);
var
	Pt:	TPoint;
begin
	if	FDragOver	and	(ssLeft	in	Shift)	then
  begin
  	Pt:=Mouse.CursorPos;
  	OffsetPt(Pt,FDragOffset,True);
    Left:=Pt.X;
    Top:=Pt.Y;
  end;

	if	([ssLeft,ssRight,ssMiddle]*Shift=[])	and
			([ssShift,ssCtrl]*Shift<>[])	then
		ViewStyle:=vsHidden;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
	FDragOver:=False;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
	Shift: TShiftState; X, Y: Integer);
begin
	if	Button=mbLeft	then
	begin
		//ܥ󥯥å
    FDragOffset:=ScreenToClient(Mouse.CursorPos);
    FDragOver:=True;
{
		ReleaseCapture;
		Perform(WM_SYSCOMMAND,SC_MOVE	or	2,0);
		Perform(WM_LBUTTONUP,0,MakeLParam(X,Y));
}
//		SetActiveWindow(QWidget_winId(Handle));
//		SetForegroundWindow(QWidget_winId(Handle));
		QWidget_setActiveWindow(Handle);
	end	else
	if	Button=mbRight	then
	begin
		//ܥ󥯥å
		if  not Locked  then
		begin
			PopupMenu1.Popup(Left+X,Top+Y);
			Exit;
		end;
	end;

	if	Assigned(AboutBox)	then
		AboutBox.SetFocus
//	else
//	if	Assigned(SetupDlg)	then
//		SetupDlg.SetFocus;
;

end;

//------------------------------------------------------------

//------------------------------------------------------------

{	TimerEvent	}

procedure TForm1.Timer1Timer(Sender: TObject);
begin
	Document.Timer1Timer;
	UpdatePosition;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
	with	Document	do
	begin
		if	(not  Locked) and
				(ViewStyle=vsNormal)	and
				(ChangeInterval>0)	and
				ChangeTimer.IsOver(ChangeInterval*60*1000)	then
		begin
			RandomChange(True);
			MascotChanged;
		end;

	end;

	Document.Timer2Timer;
end;

//------------------------------------------------------------

{	MenuEvents	}

procedure TForm1.ChangeMascotClick(Sender: TObject);
var
	AMenuItem:	TMenuItem;
begin
	AMenuItem:=Sender	as	TMenuItem;
	if	not	AMenuItem.Checked	then
	begin
		AMenuItem.Checked:=True;
		Document.CurrentMascot:=AMenuItem.Tag;
		MascotChanged;
	end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
	Close;
end;

procedure TForm1.Setup1Click(Sender: TObject);
begin
	SetupDlgActivate;
end;

procedure TForm1.Minimize1Click(Sender: TObject);
begin
	if	Visible	then
		ViewStyle:=vsMinimized
	else
		ViewStyle:=vsNormal;
end;

procedure TForm1.Open1Click(Sender: TObject);
var
	i:	Integer;
begin
	with	OpenDialog1	do
	begin
		FileName:='';
		Options:=Options+[ofAllowMultiSelect];
		if	Execute	then
		begin
			with	Document	do
			begin
				if	Files.Count>1	then
					for	i:=0	to	Files.Count-1	do
						MascotList.Add(TMascot.Create(Files[i]))
				else
					CurrentMascot:=MascotList.Add(TMascot.Create(FileName));
			end;
			InvalidateMenuItem;
//			MascotChanged;
		end;
	end;
end;

procedure TForm1.F1Click(Sender: TObject);
begin
	with	Document	do
	begin
		WindowFollowing:=not	WindowFollowing;
		F1.Checked:=WindowFollowing;
	end;
end;

procedure TForm1.T1Click(Sender: TObject);
begin
	with	Document	do
	begin
		TopMost:=not	TopMost;
		UpdateTopMost;
		T1.Checked:=TopMost;
	end;
end;

procedure TForm1.C2Click(Sender: TObject);
begin
	with	Document	do
	begin
		UseCaptionFmt:=not	UseCaptionFmt;
		C2.Checked:=UseCaptionFmt;
	end;
end;

procedure TForm1.Help1Click(Sender: TObject);
resourcestring
	ReadMeFile='ActMas.doc';
//var
//	ExeName:	string;
begin
//	ExeName:=FindExecutableEx('*.txt');
//	if	ExeName<>''	then
//		ShellExecute(Handle,nil,PChar(ExeName),PChar(ReadMeFile),nil,SW_SHOW);
end;

procedure TForm1.About1Click(Sender: TObject);
begin
	AboutBoxActivate;
end;

procedure TForm1.MoveClick(Sender: TObject);
var
	Anchor:	TAnchor;
	pt:	TPoint;
begin
	if  Sender  is  TMenuItem then
	begin
		Anchor:=TAnchor((Sender	as	TComponent).Tag);
		pt:=GetAnchorPoint(GetWorkAreaRect,Anchor);
		OffsetPt(pt,GetAnchorPoint(FormShape.Rect,Anchor),True);
		SetPosition(Self,pt);
	end;
end;

{	꡼󥻡Фư	}
procedure TForm1.N12Click(Sender: TObject);
begin
	ActivateScreenSaver(True);
end;

{	꡼󥻡Ф	}
procedure TForm1.P1Click(Sender: TObject);
const
	Labels:	array[Boolean]	of	string=(
		'(&P)',
		'߲(&P)'
	);
begin
	with	P1	do
	begin
  	SetScreenSaver(Checked);
		Checked:=not	Checked;
		Caption:=Labels[Checked];
	end;
end;

procedure TForm1.N01Click(Sender: TObject);
begin
	Document.RandomChange(True);
	UpdateView;
end;

procedure TForm1.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var
	Formats: TStrings;
begin
	Formats:=TStringList.Create;
	try
		SupportedDragFormats(Formats);
		Accept:=(Formats.IndexOf('text/uri-list')>=0)	or
						(Formats.IndexOf('_NETSCAPE_URL')>=0)	or
						(Formats.IndexOf('text/x-moz-url')>=0);
  finally
		Formats.Free
	end;
end;

procedure TForm1.FormDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  MS:	TMemoryStream;
//  i:	Integer;
begin
	MS:=TMemoryStream.Create;
	try
		if	SaveDragDataToStream(MS,'text/uri-list')	or
				SaveDragDataToStream(MS,'_NETSCAPE_URL')	or
				SaveDragDataToStream(MS,'text/x-moz-url')	then
		begin
			MS.Position:=0;
      with	TStringList.Create	do
      try
      	LoadFromStream(MS);
        ShowMessage(Text);
//        for	i:=0	to	Count-1	do
//          Document.MascotList.Add(TMascot.Create(Strings[i]));
//        InvalidateMenuItem;
      finally
      	Free;
      end;
    end;
  finally
  	MS.Free;
	end;

{
		if	SaveDragDataToStream(MS,'image/png')	or
				SaveDragDataToStream(MS,'image/jpeg')	or
				SaveDragDataToStream(MS,'image/bmp')	then
		begin
			MS.Position := 0;
      with	TPicture.Create	do
      try
				Graphic.LoadFromStream(MS);
        Bitmap;
      finally
      	Free;
      end;
		end;
}
end;

end.

