unit MakeMask;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QImgList, QExtCtrls, QMenus, contnrs;

(*
	Windows, SysUtils, Classes, Graphics, contnrs;
*)

	procedure	GraphicToMask(AGraphic:TGraphic;AMask:TBitmap);

	procedure	MakeMask8(Bmp:TBitmap;Mask:TBitmap;Flag:Boolean);
	procedure	MakeMask24(Bmp:TBitmap;Mask:TBitmap;Flag:Boolean);
	procedure	MakeMask32(Bmp:TBitmap;Mask:TBitmap;Flag:Boolean);
	procedure	MakeMaskDef(AGraphic:TGraphic;Mask:TBitmap;Flag:Boolean);

type
	TRGBTriple=packed	record
		R: Byte;
    G: Byte;
    B: Byte;
  end;
  PRGBTriple=^TRGBTriple;

	TRGBQuad=packed	record
		R: Byte;
    G: Byte;
    B: Byte;
    A: Byte;
  end;
  PRGBQuad=^TRGBQuad;

	TPointStack=class(TStack)
	public
		procedure	Push(const	Pt:TPoint);	reintroduce;	overload;
		procedure	Push(x,y:Integer);	reintroduce;	overload;
		function	Pop(var	Pt:TPoint):	Boolean;	reintroduce;	overload;
		function	Pop(var	x,y:Integer):	Boolean;	reintroduce;	overload;
	end;

type
	TByteArray=packed	array[0..Maxint	div	SizeOf(Byte)-1]	of	Byte;
	PByteArray=^TByteArray;

implementation

//VCLѤɤˡ
procedure	GraphicToMask(AGraphic:TGraphic;AMask:TBitmap);
begin
	with	AMask	do
	begin
//		HandleType:=bmDIB;
		Assign(AGraphic);
		Mask(Canvas.Pixels[0,0]);
	end;
end;

//ǥޥ(8bit)
procedure	MakeMask8(Bmp:TBitmap;Mask:TBitmap;Flag:Boolean);
var
	bgBmp:	Byte;
	bgMask:	Byte;
	x,y:	Integer;
	Width,Height:	Integer;
begin
	Width:=Bmp.Width;
	Height:=Bmp.Height;
	Bmp.PixelFormat:=pf8bit;
	Mask.Width:=Width;
	Mask.Height:=Height;
	Mask.PixelFormat:=pf8bit;
	for	y:=0	to	Height-1	do
		FillChar(Mask.ScanLine[y]^,Width,#0);
//	with	TPointQueue.Create(512)	do
	with	TPointStack.Create	do
	try
		Push(0,0);
		Push(0,Height-1);
		Push(Width-1,0);
		Push(Width-1,Height);
		bgBmp:=PByteArray(Bmp.ScanLine[0])[0];
		bgMask:=PByteArray(Mask.ScanLine[0])[0];
		while	Pop(x,y)	do
		begin
			if	(x>=0)	and	(x<Width)	and	(y>=0)	and	(y<Height)	and
					(PByteArray(Bmp.ScanLine[y])[x]=bgBmp)	and
					(PByteArray(Mask.ScanLine[y])[x]=bgMask)	then
			begin
				PByteArray(Mask.ScanLine[y])[x]:=not	bgMask;
				Push(x,y-1);		//
				Push(x,y+1);		//
				Push(x-1,y);		//
				Push(x+1,y);		//
				if	Flag	then
				begin
					Push(x-1,y-1);		//
					Push(x+1,y-1);		//
					Push(x-1,y+1);		//
					Push(x+1,y+1);		//
				end;
			end;
		end;
	finally
		Free;
	end;
end;

//ǥޥ(24bit)
procedure	MakeMask24(Bmp:TBitmap;Mask:TBitmap;Flag:Boolean);

	function	EqualRGB(const	c1,c2:TRGBQuad):	Boolean;
	begin
		Result:=CompareMem(@c1,@c2,SizeOf(TRGBTriple));
	end;

type
	TRGBTripleArray=packed	array[0..MaxInt	div	SizeOf(TRGBTriple)-1]	of	TRGBTriple;
	PRGBTripleArray=^TRGBTripleArray;
	TRGBQuadArray=packed	array[0..MaxInt	div	SizeOf(TRGBQuad)-1]	of	TRGBQuad;
	PRGBQuadArray=^TRGBQuadArray;
var
	bgBmp:	TRGBQuad;
	bgMask:	Byte;
	x,y:	Integer;
	Width,Height:	Integer;
begin
	Width:=Bmp.Width;
	Height:=Bmp.Height;
	Bmp.PixelFormat:=pf32bit;
	Mask.Width:=Width;
	Mask.Height:=Height;
	Mask.PixelFormat:=pf8bit;
	for	y:=0	to	Height-1	do
		FillChar(Mask.ScanLine[y]^,Width,#0);
//	with	TPointQueue.Create(512)	do
	with	TPointStack.Create	do
	try
		Push(0,0);
		Push(0,Height-1);
		Push(Width-1,0);
		Push(Width-1,Height);
		bgBmp:=PRGBQuadArray(Bmp.ScanLine[0])[0];
		bgMask:=PByteArray(Mask.ScanLine[0])[0];
		while	Pop(x,y)	do
		begin
			if	(x>=0)	and	(x<Width)	and	(y>=0)	and	(y<Height)	and
					EqualRGB(PRGBQuadArray(Bmp.ScanLine[y])[x],bgBmp)	and
					(PByteArray(Mask.ScanLine[y])[x]=bgMask)	then
			begin
				PByteArray(Mask.ScanLine[y])[x]:=not	bgMask;
				Push(x,y-1);		//
				Push(x,y+1);		//
				Push(x-1,y);		//
				Push(x+1,y);		//
				if	Flag	then
				begin
					Push(x-1,y-1);		//
					Push(x+1,y-1);		//
					Push(x-1,y+1);		//
					Push(x+1,y+1);		//
				end;
			end;
		end;
	finally
		Free;
	end;
end;

//ǥޥ(32bit)
procedure	MakeMask32(Bmp:TBitmap;Mask:TBitmap;Flag:Boolean);

	function	EqualRGB(const	c1,c2:TRGBQuad):	Boolean;
	begin
		Result:=CompareMem(@c1,@c2,SizeOf(TRGBQuad));
	end;

type
	TRGBQuadArray=packed	array[0..MaxInt	div	SizeOf(TRGBQuad)-1]	of	TRGBQuad;
	PRGBQuadArray=^TRGBQuadArray;
var
	bgBmp:	TRGBQuad;
	bgMask:	Byte;
	x,y:	Integer;
	Width,Height:	Integer;
begin
	Width:=Bmp.Width;
	Height:=Bmp.Height;
	Bmp.PixelFormat:=pf32bit;
	Mask.Width:=Width;
	Mask.Height:=Height;
	Mask.PixelFormat:=pf8bit;
	for	y:=0	to	Height-1	do
		FillChar(Mask.ScanLine[y]^,Width,#0);
//	with	TPointQueue.Create(512)	do
	with	TPointStack.Create	do
	try
		Push(0,0);
		Push(0,Height-1);
		Push(Width-1,0);
		Push(Width-1,Height);
		bgBmp:=PRGBQuadArray(Bmp.ScanLine[0])[0];
		bgMask:=PByteArray(Mask.ScanLine[0])[0];
		while	Pop(x,y)	do
		begin
			if	(x>=0)	and	(x<Width)	and	(y>=0)	and	(y<Height)	and
					EqualRGB(PRGBQuadArray(Bmp.ScanLine[y])[x],bgBmp)	and
					(PByteArray(Mask.ScanLine[y])[x]=bgMask)	then
			begin
				PByteArray(Mask.ScanLine[y])[x]:=not	bgMask;
				Push(x,y-1);		//
				Push(x,y+1);		//
				Push(x-1,y);		//
				Push(x+1,y);		//
				if	Flag	then
				begin
					Push(x-1,y-1);		//
					Push(x+1,y-1);		//
					Push(x-1,y+1);		//
					Push(x+1,y+1);		//
				end;
			end;
		end;
	finally
		Free;
	end;
end;

procedure	MakeMaskDef(AGraphic:TGraphic;Mask:TBitmap;Flag:Boolean);
var
	Bmp:	TBitmap;
begin
	Bmp:=TBitmap.Create;
	try
		Bmp.Assign(AGraphic);

		Assert(Assigned(Bmp.ScanLine[0]));
		Assert(Bmp.Width>0);
		Assert(Bmp.Height>0);

		case	Bmp.PixelFormat	of
			pf1bit,pf8bit:
				MakeMask8(Bmp,Mask,Flag);

			pf16bit:
				MakeMask24(Bmp,Mask,Flag);

//			pf32bit:
//				MakeMask32(Bmp,Mask,Flag);

			else
				MakeMask24(Bmp,Mask,Flag);
		end;
	finally
		Bmp.Free;
	end;
end;

//------------------------------------------------------------

{	TPointStack	}

procedure	TPointStack.Push(const	Pt:TPoint);
var
	p:	PPoint;
begin
	New(p);
	p^:=Pt;
	inherited	Push(p);
end;

procedure	TPointStack.Push(x,y:Integer);
var
	p:	PPoint;
begin
	New(p);
	p.x:=x;	p.y:=y;
	inherited	Push(p);
end;

function	TPointStack.Pop(var	Pt:TPoint):	Boolean;
var
	p:	PPoint;
begin
	Result:=False;
	if	Count>0	then
	begin
		p:=inherited	Pop();
		Pt:=p^;
		Dispose(p);
		Result:=True;
	end;
end;

function	TPointStack.Pop(var	x,y:Integer):	Boolean;
var
	p:	PPoint;
begin
	Result:=False;
	if	Count>0	then
	begin
		p:=inherited	Pop();
		x:=p.x;	y:=p.y;
		Dispose(p);
		Result:=True;
	end;
end;

end.

